"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("./util"));
var decode = function (_msg) {
    return [null];
};
var isObject = function (v) {
    return typeof v === "object" && v.required !== undefined && v.value !== undefined;
};
var encode = function (_a) {
    var value = _a.value, initialPath = _a.path;
    var isObj = typeof value === "object";
    var allowPartial = isObj && value.allowPartial !== undefined ? value.allowPartial : false;
    var attr = initialPath.split(".").pop() || "";
    var pairs = isObj
        ? Object.entries(value).map(function (_a) {
            var k = _a[0], v = _a[1];
            return isObject(v)
                ? [k, v.value.toString(), v.required]
                : [k, v.toString(), false];
        })
        : [[attr, value]];
    var path = initialPath.endsWith(".") ? initialPath : initialPath.slice(0, initialPath.lastIndexOf('.') + 1);
    return {
        lookup: "Msg",
        header: {
            lookup: "Header",
            msgId: util.uniq("SET@"),
            msgType: "SET",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                set: {
                    allowPartial: allowPartial,
                    updateObjs: [
                        {
                            lookup: "Set.UpdateObject",
                            objPath: path,
                            paramSettings: pairs
                                .filter(function (_a) {
                                var k = _a[0];
                                return k !== "allowPartial";
                            })
                                .map(function (_a) {
                                var param = _a[0], value = _a[1], required = _a[2];
                                return ({
                                    lookup: "Set.UpdateParamSetting",
                                    param: param,
                                    value: value,
                                    required: required,
                                });
                            }),
                        },
                    ],
                },
            },
        },
    };
};
exports.default = {
    decode: decode,
    encode: encode
};
